//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------

#include <cstdlib>
#include <iostream>// les classes
#include <conio.h>

#include <ExtCtrls.hpp>

#include <pngimage.hpp>

#include <stdio.h>
#include <stdlib.h>

#include "ficheprincipale.h"
                                 
enum flip_y_e { flip_y = true };

using namespace std; // vrifier et rajouter le positionnement des images et des pices

const int blanc = 0;
const int noir = 1;
const int taillecase = 64;

class piece
{
protected:
int couleur, posx, posy, actif, vide, deplacement, type; //0=rien, 1=pion, 2=cavalier, 3=tour, 4=fou, 5=reine, 6=roi
void *PEchiquier;
//TPNGGraphic *png;
TImage *image;
public: __fastcall piece(void *, int, int, int, TWinControl*);
        __fastcall ~piece();
        int __fastcall PositionX();
        int __fastcall PositionY();
        void __fastcall PositionX(int);
        void __fastcall PositionY(int);
        int __fastcall Actif();
        void __fastcall Actif(int);
        int __fastcall Vide();
        void __fastcall Vide(int);
        int __fastcall Couleur();
        void __fastcall Couleur(int);
        void __fastcall Init(int, int, int);
        void __fastcall Parent(void *);
        void* __fastcall Parent();
        int __fastcall Deplacement();
        void __fastcall Deplacement(int);
        int __fastcall Type();
        void __fastcall Type(int);
        void __fastcall Picture(AnsiString pic);
        void __fastcall SetPanel(TWinControl *Panel);
        void __fastcall PieceDragDrop(TObject *Sender, TObject *Source, int X, int Y);
        void __fastcall PieceDragOver(TObject *Sender, TObject *Source, int X, int Y, TDragState State, bool &Accept);
        void __fastcall PieceEndDock(TObject *Sender, TObject *Target, int X, int Y);
        void __fastcall PieceEndDrag(TObject *Sender, TObject *Target, int X, int Y);
        void __fastcall PieceClick(TObject *Sender);
        void __fastcall PieceStartDock(TObject *Sender, TDragDockObject *&DragObject);
        void __fastcall PieceStartDrag(TObject *Sender, TDragObject *&DragObject);
        bool __fastcall ScanRoc(piece *temppiece);
        bool __fastcall Test();
};

class pion:public piece
{
public: __fastcall pion(void *, int, int, int, TWinControl*);
        __fastcall ~pion();
        int __fastcall deplacement(int, int);
        void __fastcall Changement(int);
};

class cavalier:public piece
{
public: __fastcall cavalier(void *, int, int, int, TWinControl*);
        void __fastcall copiecavalier(cavalier *);
        __fastcall ~cavalier();
        int __fastcall deplacement(int, int);
};

class tour:public piece
{
public: int roc;
        __fastcall tour(void *, int, int, int, TWinControl*);
        void __fastcall copietour(tour *);
        __fastcall ~tour();
        int __fastcall deplacement(int, int);
};

class fou:public piece
{
public: __fastcall fou(void *, int, int, int, TWinControl*);
        void __fastcall copiefou(fou *);
        __fastcall ~fou();
        int __fastcall deplacement(int, int);
};

class roi:public piece
{
public: int roc;
        __fastcall roi(void *, int, int, int, TWinControl*);
        __fastcall ~roi();
        int __fastcall deplacement(int, int);
        int __fastcall Roc(int);
};

class reine:public piece
{
public: __fastcall reine(void *, int, int, int, TWinControl*);
        void __fastcall copiereine(reine *);
        __fastcall ~reine();
        int __fastcall deplacement(int, int);
};

class carreau
{
protected:
int ligne, colonne, couleur;
piece *Ppiece;
void *PEchiquier;
TImage *image;
//TPNGGraphic *png;
public: __fastcall carreau(void *);
        __fastcall ~carreau();
        void* __fastcall Piece();
        void __fastcall Piece(void*);
        void __fastcall Parent(void *);
        void* __fastcall Parent();
        int __fastcall PositionX();
        int __fastcall PositionY();
        void __fastcall PositionX(int);
        void __fastcall PositionY(int);
        void __fastcall Couleur(int);
        int __fastcall Couleur(void);
        void __fastcall SetPanel(TWinControl *Panel);
        TImage* __fastcall Image();
        void __fastcall CarreauDragDrop(TObject *Sender, TObject *Source, int X, int Y);
        void __fastcall CarreauDragOver(TObject *Sender, TObject *Source, int X, int Y, TDragState State, bool &Accept);
        void __fastcall CarreauEndDock(TObject *Sender, TObject *Target, int X, int Y);
        void __fastcall CarreauEndDrag(TObject *Sender, TObject *Target, int X, int Y);
        void __fastcall CarreauClick(TObject *Sender);
        void __fastcall CarreauStartDock(TObject *Sender, TDragDockObject *&DragObject);
        void __fastcall CarreauStartDrag(TObject *Sender, TDragObject *&DragObject);
};

class Echiquier
{
protected:
        void *Pparent;
public:
        TList *Prevision;
        piece *Ppiecevide;
        carreau *Pcarreau;
        pion *Ppion;
        cavalier *Pcavalier;
        tour *Ptour;
        fou *Pfou;
        roi *Proi;
        reine *Preine;
        pion *dernierpion;
        piece *drag;
        int Nbcavalier, Nbtour, Nbfou, Nbreine, coups;
        bool sens;
        __fastcall Echiquier(void *owner=NULL, bool Fsens=0); // constructeur avec paramtre facultatif
        __fastcall ~Echiquier();
        int __fastcall EstEchec(int);
        int __fastcall EstEchec(int, int, int);
        int __fastcall EstEchec(int, int, int, int, int);
        int __fastcall CaseEchec(int, int, int);
        int __fastcall EstMat(int);
        void* __fastcall Parent();
        void __fastcall Parent(void *Parent);
        bool __fastcall DeplacementPossible(int);
};
//---------------------------------------------------------------------------
#endif
